<?php

if ( ! defined( 'ABSPATH' ) )
	exit;

if ( !class_exists( 'ewdDashboardForms' ) ) {
class ewdDashboardForms {

	public function __construct() {

		add_filter( 'ewd_dashboard_top', array( $this, 'display_upgrade_form' ), 10, 3 );
		add_filter( 'ewd_dashboard_top_kses_allowed_tags', array( $this, 'allowed_tags_upgrade_form' ), 10 );
		add_filter( 'ewd_trial_button', array( $this, 'display_trial_form' ), 10, 2 );

		add_action( 'ewd_trial_happening', array( $this, 'display_trial_information' ), 10, 1 );
	}

	public function display_trial_form( $string, $plugin ) {

		ewdph_enqueue_admin_assets();

		$form_action = $this->get_form_action( $plugin );

		$trial_form = '<form method="post" action="' . $form_action . '">';
		$trial_form .= '<input name="key" type="hidden" value="EWD Trial">';
		$trial_form .= '<input type="hidden" name="plugin_name" value="' . $plugin . '" />';
		$trial_form .= '<input name="ewd_upgrade_to_full" type="hidden" value="ewd_upgrade_to_full">';
		$trial_form .= '<button class="ewd-premium-helper-dashboard-get-premium-widget-button ewd-premium-helper-dashboard-new-trial-button">GET FREE 7-DAY TRIAL</button>';
		$trial_form .= '</form>';

		return $trial_form;
	}

	public function display_upgrade_form( $string, $plugin, $link ) {

		ewdph_enqueue_admin_assets();

		$form_action = $this->get_form_action( $plugin );

		$unlock_version = $plugin == 'UWPM' ? 'ultimate' : 'premium';

		$upgrade_form = '<div class="ewd-premium-helper-dashboard-new-widget-box ewd-widget-box-full">';
		$upgrade_form .= '<div class="ewd-premium-helper-dashboard-new-widget-box-top">';
		$upgrade_form .= '<form method="post" action="' . $form_action . '" class="ewd-premium-helper-dashboard-key-widget">';
		$upgrade_form .= '<input class="ewd-premium-helper-dashboard-key-widget-input" name="key" type="text" placeholder="' . __('Enter Product Key Here', 'ewd-premium-helper') . '">';
		$upgrade_form .= '<input type="hidden" name="plugin_name" value="' . $plugin . '" />';
		$upgrade_form .= '<input class="ewd-premium-helper-dashboard-key-widget-submit" name="ewd_upgrade_to_full" type="submit" value="' . __('UNLOCK ', 'ewd-premium-helper') . $unlock_version . '">';
		$upgrade_form .= '<div class="ewd-premium-helper-dashboard-key-widget-text">' . sprintf( __( "Don't have a key? Use the <a href='%s&utm_source=" . $plugin . "_admin&utm_content=enter_key_field' target='_blank'>UPGRADE NOW</a> button above to purchase and unlock all " . $unlock_version . " features.", "ewd-premium-helper" ), $link ) . '</div>';
		$upgrade_form .= '</form>';
		$upgrade_form .= '</div>';
		$upgrade_form .= '</div>';
		
		return $upgrade_form;

	}

	public function allowed_tags_upgrade_form( $allowed_tags )
	{
		$allowed_atts = array(
			'id' => array(),
			'name' => array(),
			'type' => array(),
			'class' => array(),
			'style' => array(),
			'value' => array(),
			'method' => array(),
			'action' => array(),
			'placeholder' => array()
		);

		$allowed_tags = array_merge(
			$allowed_tags,
			[
				'form'  => $allowed_atts,
				'input' => $allowed_atts
			]
		);

		return $allowed_tags;
	}

	public function display_trial_information( $plugin ) {

		ewdph_enqueue_admin_assets();

		$trial_expiry_time = get_option("EWD_" . $plugin . "_Trial_Expiry_Time");

		if ( ! $trial_expiry_time ) { return; }

		$current_time = time();
		$trial_time_left = $trial_expiry_time - $current_time;
		$trial_time_left_days = date("d", $trial_time_left) - 1;
		$trial_time_left_hours = date("H", $trial_time_left);
		
		?>

		<div class="ewd-premium-helper-dashboard-new-widget-box-bottom">
			<div class="ewd-premium-helper-dashboard-get-premium-widget-trial-time">
				<div class="ewd-premium-helper-dashboard-get-premium-widget-trial-days"><?php echo $trial_time_left_days; ?><span>days</span></div>
				<div class="ewd-premium-helper-dashboard-get-premium-widget-trial-hours"><?php echo $trial_time_left_hours; ?><span>hours</span></div>
			</div>
			<div class="ewd-premium-helper-dashboard-get-premium-widget-trial-time-left">LEFT IN TRIAL</div>
		</div>
	
	<?php }

	public function get_form_action( $plugin ) {

		switch ( $plugin ) {

			case 'UASP':
				return 'admin.php?page=ewd-uasp-dashboard';
				break;

			case 'UFAQ':
				return 'admin.php?page=ewd-ufaq-dashboard';
				break;

			case 'US':
				return 'edit.php?post_type=ultimate_slider';
				break;
	
			case 'URP':
				return 'admin.php?page=ewd-urp-dashboard';
				break;

			case 'UWCF':
				return 'admin.php?page=ewd-uwcf-dashboard';
				break;

			case 'OTP':
				return 'admin.php?page=ewd-otp-dashboard';
				break;

			case 'UPCP':
				return 'admin.php?page=ewd-upcp-dashboard';
				break;

			case 'UWPM':
				return 'admin.php?page=ewd-uwpm-dashboard';
				break;

			default:
				return 'admin.php?page=EWD-' . $plugin . '-options';
				break;
		}		
	}
}
}