<?php 

if ( ! defined( 'ABSPATH' ) )
	exit;

if ( !class_exists( 'ewdHandleVersionReversion' ) ) {
class ewdHandleVersionReversion {

	public function __construct() {

		if ( get_option( "EWD_FEUP_Trial_Happening" ) == "Yes" and time() > get_option( "EWD_FEUP_Trial_Expiry_Time" ) ) { add_action( 'admin_init', array( $this, 'ewd_feup_version_reversion' ) ); }
		if ( get_option( "EWD_OTP_Trial_Happening" ) == "Yes" and time() > get_option( "EWD_OTP_Trial_Expiry_Time" ) ) { add_action( 'admin_init', array( $this, 'ewd_otp_version_reversion' ) ); }
		if ( get_option( "EWD_UASP_Trial_Happening" ) == "Yes" and time() > get_option( "EWD_UASP_Trial_Expiry_Time" ) ) { add_action( 'admin_init', array( $this, 'ewd_uasp_version_reversion' ) ); }
		if ( get_option( "EWD_UFAQ_Trial_Happening" ) == "Yes" and time() > get_option( "EWD_UFAQ_Trial_Expiry_Time" ) ) { add_action( 'admin_init', array( $this, 'ewd_ufaq_version_reversion' ) ); }
		if ( get_option( "EWD_UPCP_Trial_Happening" ) == "Yes" and time() > get_option( "EWD_UPCP_Trial_Expiry_Time" ) ) { add_action( 'admin_init', array( $this, 'ewd_upcp_version_reversion' ) ); }
		if ( get_option( "EWD_URP_Trial_Happening" ) == "Yes" and time() > get_option( "EWD_URP_Trial_Expiry_Time" ) ) { add_action( 'admin_init', array( $this, 'ewd_urp_version_reversion' ) ); }
		if ( get_option( "EWD_US_Trial_Happening" ) == "Yes" and time() > get_option( "EWD_US_Trial_Expiry_Time" ) ) { add_action( 'admin_init', array( $this, 'ewd_us_version_reversion' ) ); }
		if ( get_option( "EWD_UWCF_Trial_Happening" ) == "Yes" and time() > get_option( "EWD_UWCF_Trial_Expiry_Time" ) ) { add_action( 'admin_init', array( $this, 'ewd_uwcf_version_reversion' ) ); }
	}

	public function ewd_plugin_deactivation_reversion() {

		if ( get_option( "EWD_FEUP_Full_Version" ) and get_option( "EWD_FEUP_Trial_Happening" ) == "Yes" ) { $this->ewd_feup_version_reversion(); }
		if ( get_option( "EWD_OTP_Full_Version" ) and get_option( "EWD_OTP_Trial_Happening" ) == "Yes" ) { $this->ewd_otp_version_reversion(); }
		if ( get_option( "EWD_UASP_Full_Version" ) and get_option( "EWD_UASP_Trial_Happening" ) == "Yes" ) { $this->ewd_uasp_version_reversion(); }
		if ( get_option( "EWD_UFAQ_Full_Version" ) and get_option( "EWD_UFAQ_Trial_Happening" ) == "Yes" ) { $this->ewd_ufaq_version_reversion(); }
		if ( get_option( "UPCP_Full_Version" ) and get_option( "UPCP_Trial_Happening" ) == "Yes" ) { $this->ewd_upcp_version_reversion(); }
		if ( get_option( "EWD_URP_Full_Version" ) and get_option( "EWD_URP_Trial_Happening" ) == "Yes" ) { $this->ewd_urp_version_reversion(); }
		if ( get_option( "EWD_US_Full_Version" ) and get_option( "EWD_US_Trial_Happening" ) == "Yes" ) { $this->ewd_us_version_reversion(); }
		if ( get_option( "EWD_UWCF_Full_Version" ) and get_option( "EWD_UWCF_Trial_Happening" ) == "Yes" ) { $this->ewd_uwcf_version_reversion(); }
	}

	public function ewd_feup_version_reversion() {

		update_option( "EWD_FEUP_Use_Captcha", "No" );
		update_option( "EWD_FEUP_Allow_Level_Choice", "No" );
		update_option( "EWD_FEUP_Track_Events", "No" );
		update_option( "EWD_FEUP_Email_Confirmation", "No" );
		update_option( "EWD_FEUP_Admin_Approval", "No" );
		update_option( "EWD_FEUP_Email_On_Admin_Approval", "No" );
		update_option( "EWD_FEUP_Admin_Email_On_Registration", "No" );
		update_option( "EWD_FEUP_Create_WordPress_Users", "No" );
		update_option( "EWD_FEUP_Login_Options", array() );

		update_option( "EWD_FEUP_Label_Login", "" );
		update_option( "EWD_FEUP_Label_Logout", "" );
		update_option( "EWD_FEUP_Label_Username", "" );
		update_option( "EWD_FEUP_Label_Register", "" );
		update_option( "EWD_FEUP_Label_Successful_Logout_Message", "" );
		update_option( "EWD_FEUP_Label_Require_Login_Message", "" );

		update_option( "EWD_FEUP_Label_Upgrade_Account", "" );
		update_option( "EWD_FEUP_Label_Update_Account", "" );
		update_option( "EWD_FEUP_Label_Upgrade_Level_Message", "" );
		update_option( "EWD_FEUP_Label_Level", "" );
		update_option( "EWD_FEUP_Label_Next", "" );
		update_option( "EWD_FEUP_Label_Discount_Message", "" );
		update_option( "EWD_FEUP_Label_Discount_Code", "" );
		update_option( "EWD_FEUP_Label_Use_Discount_Code", "" );
		update_option( "EWD_FEUP_Label_Edit_Profile", "" );
		update_option( "EWD_FEUP_Label_Current_File", "" );
		update_option( "EWD_FEUP_Label_Current_Picture", "" );
		update_option( "EWD_FEUP_Label_Update_Picture", "" );
		update_option( "EWD_FEUP_Label_Confirm_Email_Message", "" );
		update_option( "EWD_FEUP_Label_Incorrect_Confirm_Message", "" );
		update_option( "EWD_FEUP_Label_Captcha_Fail", "" );
		update_option( "EWD_FEUP_Label_Login_Successful", "" );
		update_option( "EWD_FEUP_Label_Login_Failed_Confirm_Email", "" );
		update_option( "EWD_FEUP_Label_Select_Valid_Profile", "" );
		update_option( "EWD_FEUP_Label_Nonlogged_Message", "" );
		update_option( "EWD_FEUP_Label_Low_Account_Level_Message", "" );
		update_option( "EWD_FEUP_Label_High_Account_Level_Message", "" );
		update_option( "EWD_FEUP_Label_Wrong_Account_Level_Message", "" );
		update_option( "EWD_FEUP_Label_Restrict_Access_Message", "" );
		update_option( "EWD_FEUP_Label_Login_Failed_Admin_Approval", "" );
		update_option( "EWD_FEUP_Label_Login_Failed_Payment_Required", "" );
		update_option( "EWD_FEUP_Label_Login_Failed_Incorrect_Credentials", "" );

		update_option( "EWD_FEUP_Label_Please", "" );
		update_option( "EWD_FEUP_Label_To_Continue", "" );
		update_option( "EWD_FEUP_Label_Password", "" );
		update_option( "EWD_FEUP_Label_Repeat_Password", "" );
		update_option( "EWD_FEUP_Label_Password_Strength", "" );
		update_option( "EWD_FEUP_Label_Reset_Password", "" );
		update_option( "EWD_FEUP_Label_Email", "" );
		update_option( "EWD_FEUP_Label_Reset_Code", "" );
		update_option( "EWD_FEUP_Label_Change_Password", "" );
		update_option( "EWD_FEUP_Label_Too_Short", "" );
		update_option( "EWD_FEUP_Label_Mismatch", "" );
		update_option( "EWD_FEUP_Label_Weak", "" );
		update_option( "EWD_FEUP_Label_Good", "" );
		update_option( "EWD_FEUP_Label_Strong", "" );

		update_option( "EWD_FEUP_Styling_Form_Font", "" );
		update_option( "EWD_FEUP_Styling_Form_Font_Size", "" );
		update_option( "EWD_FEUP_Styling_Form_Font_Weight", "" );
		update_option( "EWD_FEUP_Styling_Form_Font_Color", "" );
		update_option( "EWD_FEUP_Styling_Form_Margin", "" );
		update_option( "EWD_FEUP_Styling_Form_Padding", "" );
		update_option( "EWD_FEUP_Styling_Submit_Bg_Color", "" );
		update_option( "EWD_FEUP_Styling_Submit_Font", "" );
		update_option( "EWD_FEUP_Styling_Submit_Font_Color", "" );
		update_option( "EWD_FEUP_Styling_Submit_Margin", "" );
		update_option( "EWD_FEUP_Styling_Submit_Padding", "" );

		update_option( "EWD_FEUP_Styling_Userlistings_Font", "" );
		update_option( "EWD_FEUP_Styling_Userlistings_Font_Size", "" );
		update_option( "EWD_FEUP_Styling_Userlistings_Font_Weight", "" );
		update_option( "EWD_FEUP_Styling_Userlistings_Font_Color", "" );
		update_option( "EWD_FEUP_Styling_Userlistings_Margin", "" );
		update_option( "EWD_FEUP_Styling_Userlistings_Padding", "" );
		update_option( "EWD_FEUP_Styling_Userprofile_Label_Font", "" );
		update_option( "EWD_FEUP_Styling_Userprofile_Label_Font_Size", "" );
		update_option( "EWD_FEUP_Styling_Userprofile_Label_Font_Weight", "" );
		update_option( "EWD_FEUP_Styling_Userprofile_Label_Font_Color", "" );
		update_option( "EWD_FEUP_Styling_Userprofile_Content_Font", "" );
		update_option( "EWD_FEUP_Styling_Userprofile_Content_Font_Size", "" );
		update_option( "EWD_FEUP_Styling_Userprofile_Content_Font_Weight", "" );
		update_option( "EWD_FEUP_Styling_Userprofile_Content_Font_Color", "" );

		update_option( "EWD_FEUP_Full_Version", "No" );
		update_option( "EWD_FEUP_Trial_Happening", "No" );
		delete_option( "EWD_FEUP_Trial_Expiry_Time" );
	}	

	public function ewd_otp_version_reversion() {
		global $ewd_otp_controller;

 		if ( ! empty( $ewd_otp_controller ) and is_object( $ewd_otp_controller ) ) {

 			if ( $ewd_otp_controller->settings->get_setting( 'woocommerce-integration' ) and empty( $ewd_otp_controller->settings->get_setting( 'woocommerce-disable-revert-statuses' ) )  ) {

 				$ewd_otp_controller->woocommerce->revert_statuses();
 			}

 			$ewd_otp_controller->settings->set_setting( 'woocommerce-integration', '' );
 			$ewd_otp_controller->settings->set_setting( 'zendesk-integration', '' );
 			$ewd_otp_controller->settings->set_setting( 'tracking-graphic', 'default' );
 			$ewd_otp_controller->settings->set_setting( 'customer-notes-email', '' );
 			$ewd_otp_controller->settings->set_setting( 'customer-order-email', '' );
 			$ewd_otp_controller->settings->set_setting( 'allow-order-payments', '' );

 			$ewd_otp_controller->settings->set_setting( 'label-order-form-title', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-form-number', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-form-number-placeholder', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-form-email', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-form-email-placeholder', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-form-button', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-retrieving-results', '' );
 			$ewd_otp_controller->settings->set_setting( 'customer-form-title', '' );
 			$ewd_otp_controller->settings->set_setting( 'customer-form-instructions', '' );
 			$ewd_otp_controller->settings->set_setting( 'customer-form-number', '' );
 			$ewd_otp_controller->settings->set_setting( 'customer-form-number-placeholder', '' );
 			$ewd_otp_controller->settings->set_setting( 'customer-form-email', '' );
 			$ewd_otp_controller->settings->set_setting( 'customer-form-email-placeholder', '' );
 			$ewd_otp_controller->settings->set_setting( 'customer-form-button', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-sales-rep-form-title', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-sales-rep-form-instructions', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-sales-rep-form-number', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-sales-rep-form-number-placeholder', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-sales-rep-form-email', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-sales-rep-form-email-placeholder', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-sales-rep-form-button', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-information', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-number', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-name', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-notes', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-customer-notes', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-status', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-location', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-updated', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-current-location', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-print-button', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-add-note-button', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-order-update-status', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-customer-display-name', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-customer-display-email', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-customer-display-download', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-sales-rep-display-first-name', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-sales-rep-display-last-name', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-customer-order-name', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-customer-order-email', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-customer-order-notes', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-customer-order-button', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-customer-order-thank-you', '' );
 			$ewd_otp_controller->settings->set_setting( 'label-customer-order-email-instructions', '' );
 			
 			$ewd_otp_controller->settings->set_setting( 'styling-title-font', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-title-font-size', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-title-font-color', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-title-margin', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-title-padding', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-label-font', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-label-font-size', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-label-font-color', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-label-margin', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-label-padding', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-content-font', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-content-font-size', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-content-font-color', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-content-margin', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-content-padding', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-button-font-color', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-button-background-color', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-button-border', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-button-margin', '' );
 			$ewd_otp_controller->settings->set_setting( 'styling-button-padding', '' );
 			
 			$ewd_otp_controller->settings->save_settings();

			update_option( 'ewd-otp-permission-level', 1 );
 		}
 		else {

			if ( get_option( "EWD_OTP_WooCommerce_Integration" ) == "Yes" and get_option( "EWD_OTP_Replace_WooCommerce_Statuses" ) == "Yes" ) { $this->ewd_otp_trial_end_wc_status_check(); }

			update_option( "EWD_OTP_Access_Role", "administrator" );
			update_option( "EWD_OTP_WooCommerce_Integration", "No" );
			update_option( "EWD_OTP_Display_Graphic", "Default" );
			update_option( "EWD_OTP_Mobile_Stylesheet", "No" );
			update_option( "EWD_OTP_Customer_Notes_Email", "None" );
			update_option( "EWD_OTP_Customer_Order_Email", "None" );

			update_option( "EWD_OTP_Allow_Order_Payments", "No" );

			update_option( "EWD_OTP_Tracking_Title_Label", "" );
			update_option( "EWD_OTP_Tracking_Ordernumber_Label", "" );
			update_option( "EWD_OTP_Tracking_Email_Label", "" );
			update_option( "EWD_OTP_Tracking_Button_Label", "" );
			update_option( "EWD_OTP_Order_Information_Label", "" );
			update_option( "EWD_OTP_Order_Number_Label", "" );
			update_option( "EWD_OTP_Order_Name_Label", "" );
			update_option( "EWD_OTP_Order_Notes_Label", "" );
			update_option( "EWD_OTP_Customer_Notes_Label", "" );
			update_option( "EWD_OTP_Order_Status_Label", "" );
			update_option( "EWD_OTP_Order_Location_Label", "" );
			update_option( "EWD_OTP_Order_Updated_Label", "" );

			update_option( "EWD_OTP_Styling_Title_Font", "" );
			update_option( "EWD_OTP_Styling_Title_Font_Size", "" );
			update_option( "EWD_OTP_Styling_Title_Font_Color", "" );
			update_option( "EWD_OTP_Styling_Label_Font", "" );
			update_option( "EWD_OTP_Styling_Label_Font_Size", "" );
			update_option( "EWD_OTP_Styling_Label_Font_Color", "" );
			update_option( "EWD_OTP_Styling_Content_Font", "" );
			update_option( "EWD_OTP_Styling_Content_Font_Size", "" );
			update_option( "EWD_OTP_Styling_Content_Font_Color", "" );
			update_option( "EWD_OTP_Styling_Title_Margin", "" );
			update_option( "EWD_OTP_Styling_Title_Padding", "" );
			update_option( "EWD_OTP_Styling_Body_Margin", "" );
			update_option( "EWD_OTP_Styling_Body_Padding", "" );
			update_option( "EWD_OTP_Styling_Button_Font_Color", "" );
			update_option( "EWD_OTP_Styling_Button_Bg_Color", "" );
			update_option( "EWD_OTP_Styling_Button_Border", "" );
			update_option( "EWD_OTP_Styling_Button_Margin", "" );
			update_option( "EWD_OTP_Styling_Button_Padding", "" );

			update_option( "EWD_OTP_Full_Version", "No" );
		}

		update_option( "EWD_OTP_Trial_Happening", "No" );
		delete_option( "EWD_OTP_Trial_Expiry_Time" );
	}

 	public function ewd_uasp_version_reversion() {
 		global $ewd_uasp_controller;

 		if ( ! empty( $ewd_uasp_controller ) and is_object( $ewd_uasp_controller ) ) {

 			$ewd_uasp_controller->settings->set_setting( 'booking-form-style', 'standard' );
 			$ewd_uasp_controller->settings->set_setting( 'admin-appointment-notification', '' );
 			$ewd_uasp_controller->settings->set_setting( 'service-provider-notification', '' );
 			$ewd_uasp_controller->settings->set_setting( 'use-captcha', '' );
 			$ewd_uasp_controller->settings->set_setting( 'access-role', '' );
 			$ewd_uasp_controller->settings->set_setting( 'require-login', '' );
 			
 			$ewd_uasp_controller->settings->set_setting( 'custom-fields', null );
 			$ewd_uasp_controller->settings->set_setting( 'email-reminders', null );

 			$ewd_uasp_controller->settings->set_setting( 'woocommerce-integration', '' );
 			$ewd_uasp_controller->settings->set_setting( 'paypal-prepayment', 'no' );

 			$ewd_uasp_controller->settings->set_setting( 'label-sign-up-title', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-name', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-phone', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-email', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-service-title', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-location', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-service', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-service-provider', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-any', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-appointment-title', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-appointment-date', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-find-appointment', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-book-appointment', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-pay-in-advance', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-proceed-to-payment', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-select-time', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-click-select-date', '' );
 			$ewd_uasp_controller->settings->set_setting( 'label-image-number', '' );

 			$ewd_uasp_controller->settings->set_setting( 'styling-signup-title-font', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-signup-title-font-size', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-signup-title-font-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-signup-label-font', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-signup-label-font-size', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-signup-block-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-signup-block-margin', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-signup-block-padding', '' );

 			$ewd_uasp_controller->settings->set_setting( 'styling-service-title-font', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-service-title-font-size', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-service-title-font-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-service-label-font', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-service-label-font-size', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-service-block-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-service-block-margin', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-service-block-padding', '' );

 			$ewd_uasp_controller->settings->set_setting( 'styling-appointment-title-font', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-appointment-title-font-size', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-appointment-title-font-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-appointment-label-font', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-appointment-label-font-size', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-appointment-block-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-appointment-block-margin', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-appointment-block-padding', '' );

 			$ewd_uasp_controller->settings->set_setting( 'styling-button-font', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-button-font-size', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-button-font-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-button-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-button-margin', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-button-padding', '' );

 			$ewd_uasp_controller->settings->set_setting( 'styling-email-background-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-email-inner-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-email-text-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-email-button-bg-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-email-button-text-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-email-button-bg-hover-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-email-button-text-hover-color', '' );

 			$ewd_uasp_controller->settings->set_setting( 'styling-calendar-appt-font', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-calendar-appt-font-size', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-calendar-appt-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-calendar-appt-bg-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-calendar-appt-border-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-calendar-appt-selected-bg-color', '' );
 			$ewd_uasp_controller->settings->set_setting( 'styling-calendar-appt-selected-border-color', '' );


			$ewd_uasp_controller->settings->save_settings();

			update_option( 'ewd-uasp-permission-level', 1 );

 		}
 		else {
		
			update_option( "EWD_UASP_Admin_Email_Notification", -1 );
			update_option( "EWD_UASP_Provider_Email_Notification", -1 );
			update_option( "EWD_UASP_Add_Captcha", "No" );
			update_option( "EWD_UASP_Require_Login", "No" );
			update_option( "EWD_UASP_Login_Options", array() );
		
		    update_option( "EWD_UASP_WooCommerce_Integration", "No" );
			update_option( "EWD_UASP_Allow_Paypal_Prepayment", "No" );
		
			update_option( "EWD_UASP_Email_Reminders", array() );
			update_option( "EWD_UASP_Appointment_Confirmation", "No" );
			
			update_option( "EWD_UASP_Signup_Title_Font", "" );
			update_option( "EWD_UASP_Signup_Title_Font_Size", "" );
			update_option( "EWD_UASP_Signup_Title_Font_Color", "" );
			update_option( "EWD_UASP_Signup_Label_Font", "" );
			update_option( "EWD_UASP_Signup_Label_Font_Size", "" );
			update_option( "EWD_UASP_Signup_Block_Color", "" );
			update_option( "EWD_UASP_Signup_Block_Margin", "" );
			update_option( "EWD_UASP_Signup_Block_Padding", "" );
		
			update_option( "EWD_UASP_Service_Title_Font", "" );
			update_option( "EWD_UASP_Service_Title_Font_Size", "" );
			update_option( "EWD_UASP_Service_Title_Font_Color", "" );
			update_option( "EWD_UASP_Service_Label_Font", "" );
			update_option( "EWD_UASP_Service_Label_Font_Size", "" );
			update_option( "EWD_UASP_Service_Block_Color", "" );
			update_option( "EWD_UASP_Service_Block_Margin", "" );
			update_option( "EWD_UASP_Service_Block_Padding", "" );
		
			update_option( "EWD_UASP_Appointment_Title_Font", "" );
			update_option( "EWD_UASP_Appointment_Title_Font_Size", "" );
			update_option( "EWD_UASP_Appointment_Title_Font_Color", "" );
			update_option( "EWD_UASP_Appointment_Label_Font", "" );
			update_option( "EWD_UASP_Appointment_Label_Font_Size", "" );
			update_option( "EWD_UASP_Appointment_Block_Color", "" );
			update_option( "EWD_UASP_Appointment_Block_Margin", "" );
			update_option( "EWD_UASP_Appointment_Block_Padding", "" );
	
			update_option( "EWD_UASP_Button_Font", "" );
			update_option( "EWD_UASP_Button_Font_Size", "" );
			update_option( "EWD_UASP_Button_Font_Color", "" );
			update_option( "EWD_UASP_Button_Color", "" );
			update_option( "EWD_UASP_Button_Margin", "" );
			update_option( "EWD_UASP_Button_Padding", "" );
	
			update_option( "EWD_UASP_Email_Reminder_Background_Color", "" );
			update_option( "EWD_UASP_Email_Reminder_Inner_Color", "" );
			update_option( "EWD_UASP_Email_Reminder_Text_Color", "" );
			update_option( "EWD_UASP_Email_Reminder_Button_Background_Color", "" );
			update_option( "EWD_UASP_Email_Reminder_Button_Background_Hover_Color", "" );
			update_option( "EWD_UASP_Email_Reminder_Button_Text_Color", "" );
			update_option( "EWD_UASP_Email_Reminder_Button_Text_Hover_Color", "" );
	
			update_option( "EWD_UASP_Calendar_Appointment_Font_Size", "" );
			update_option( "EWD_UASP_Calendar_Appointment_Font_Family", "" );
			update_option( "EWD_UASP_Calendar_Appointment_Color", "" );
			update_option( "EWD_UASP_Calendar_Appointment_Background_Color", "" );
			update_option( "EWD_UASP_Calendar_Appointment_Border_Color", "" );
			update_option( "EWD_UASP_Calendar_Selected_Appointment_Background_Color", "" );
			update_option( "EWD_UASP_Calendar_Selected_Appointment_Border_Color", "" );
	
			update_option( "EWD_UASP_Full_Version", "No" );
		}

		update_option( "EWD_UASP_Trial_Happening", "No" );
		delete_option( "EWD_UASP_Trial_Expiry_Time" );
	}

	public function ewd_ufaq_version_reversion() {
		global $ewd_ufaq_controller;

		if ( ! empty( $ewd_ufaq_controller ) and is_object( $ewd_ufaq_controller ) ) {

			$ewd_ufaq_controller->settings->set_setting( 'display-style', 'default' );
			$ewd_ufaq_controller->settings->set_setting( 'number-of-columns', 'one' );
			$ewd_ufaq_controller->settings->set_setting( 'reveal-effect', 'none' );
			$ewd_ufaq_controller->settings->set_setting( 'faqs-per-page', '' );
			$ewd_ufaq_controller->settings->set_setting( 'faq-ratings', '' );
			$ewd_ufaq_controller->settings->set_setting( 'pretty-permalinks', '' );
			$ewd_ufaq_controller->settings->set_setting( 'social-media', array() );
			$ewd_ufaq_controller->settings->set_setting( 'woocommerce-faqs', '' );
			$ewd_ufaq_controller->settings->set_setting( 'wpforms-integration', '' );
			$ewd_ufaq_controller->settings->set_setting( 'faq-elements-order', null );

			$ewd_ufaq_controller->settings->set_setting( 'faq-order-by', $ewd_ufaq_controller->settings->get_setting( 'faq-order-by' ) != 'set_order' ? $ewd_ufaq_controller->settings->get_setting( 'faq-order-by' ) : 'date' );

			$ewd_ufaq_controller->settings->set_setting( 'faq-fields', null );

			$ewd_ufaq_controller->settings->set_setting( 'label-posted', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-by', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-on', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-categories', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-tags', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-enter-question', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-search', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-permalink', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-back-to-top', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-woocommerce-tab', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-share-faq', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-find-faq-helpful', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-search-placeholder', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-thank-you-submit', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-submit-question', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-please-fill-form-below', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-send-question', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-question-title', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-question-title-explanation', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-proposed-answer', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-proposed-answer-explanation', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-question-author', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-question-author-explanation', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-question-author-email', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-question-author-email-explanation', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-captcha-image-number', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-retrieving-results', '' );
			$ewd_ufaq_controller->settings->set_setting( 'label-no-results-found', '' );

			$ewd_ufaq_controller->settings->set_setting( 'styling-toggle-symbol', 'A' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-toggle-background-color', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-toggle-font-color', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-toggle-border-size', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-toggle-border-color', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-toggle-border-radius', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-toggle-symbol-size', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-block-background-color', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-block-font-color', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-list-font', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-list-font-size', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-list-font-color', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-list-margin', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-list-padding', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-question-font', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-question-font-size', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-question-font-color', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-question-margin', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-question-padding', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-question-icon-top-margin', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-answer-font', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-answer-font-size', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-answer-font-color', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-answer-margin', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-answer-padding', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-postdate-font', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-postdate-font-size', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-postdate-font-color', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-postdate-margin', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-postdate-padding', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-category-heading-type', 'h3' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-faq-heading-type', 'h4' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-category-heading-font-color', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-category-heading-font', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-category-heading-font-size', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-category-font', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-category-font-size', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-category-font-color', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-category-margin', '' );
			$ewd_ufaq_controller->settings->set_setting( 'styling-category-padding', '' );

			$ewd_ufaq_controller->settings->save_settings();

			update_option( 'ewd-ufaq-permission-level', 1 );
		}
		else {

			update_option("EWD_UFAQ_Display_Style", "Default" );
			update_option("EWD_UFAQ_Color_Block_Shape", "Square" );
			update_option("EWD_UFAQ_FAQ_Ratings", "No" );
			update_option("EWD_UFAQ_WooCommerce_FAQs", "No" );
			update_option("EWD_UFAQ_Use_Product", "Yes" );
			update_option("EWD_UFAQ_Reveal_Effect", "none" );
			update_option("EWD_UFAQ_Pretty_Permalinks", "No" );
			update_option("EWD_UFAQ_Allow_Proposed_Answer", "No" );
			update_option("EWD_UFAQ_Admin_Question_Notification", "No" );
			update_option("EWD_UFAQ_Auto_Complete_Titles", "Yes" );
			update_option("EWD_UFAQ_Slug_Base", "ufaqs");
	
	    	update_option( "EWD_UFAQ_Order_By", "date" );
	
			update_option( "EWD_UFAQ_FAQ_Fields", array() );
	
			update_option( "EWD_UFAQ_Posted_Label", "" );
			update_option( "EWD_UFAQ_By_Label", "" );
			update_option( "EWD_UFAQ_On_Label", "" );
			update_option( "EWD_UFAQ_Category_Label", "" );
			update_option( "EWD_UFAQ_Tag_Label", "" );
			update_option( "EWD_UFAQ_Enter_Question_Label", "" );
			update_option( "EWD_UFAQ_Search_Label", "" );
			update_option( "EWD_UFAQ_Permalink_Label", "" );
			update_option( "EWD_UFAQ_Back_To_Top_Label", "" );
		
			update_option( "EWD_UFAQ_Thank_You_Submit_Label", "" );
			update_option( "EWD_UFAQ_Submit_Question_Label", "" );
			update_option( "EWD_UFAQ_Please_Fill_Form_Below_Label", "" );
			update_option( "EWD_UFAQ_Send_Question_Label", "" );
			update_option( "EWD_UFAQ_Question_Title_Label", "" );
			update_option( "EWD_UFAQ_What_Question_Being_Answered_Label", "" );
			update_option( "EWD_UFAQ_Proposed_Answer_Label", "" );
			update_option( "EWD_UFAQ_Review_Author_Label", "" );
			update_option( "EWD_UFAQ_What_Name_With_Review_Label", "" );
			update_option( "EWD_UFAQ_Retrieving_Results", "" );
			update_option( "EWD_UFAQ_No_Results_Found_Text", "" );
	
			update_option( "EWD_UFAQ_Styling_Default_Bg_Color", "" );
			update_option( "EWD_UFAQ_Styling_Default_Font_Color", "" );
			update_option( "EWD_UFAQ_Styling_Default_Border", "" );
			update_option( "EWD_UFAQ_Styling_Default_Border_Radius", "" );
			update_option( "EWD_UFAQ_Styling_Block_Bg_Color", "" );
			update_option( "EWD_UFAQ_Styling_Block_Font_Color", "" );
			update_option( "EWD_UFAQ_Styling_List_Font", "" );
			update_option( "EWD_UFAQ_Styling_List_Font_Size", "" );
			update_option( "EWD_UFAQ_Styling_List_Font_Color", "" );
			update_option( "EWD_UFAQ_Styling_List_Margin", "" );
			update_option( "EWD_UFAQ_Styling_List_Padding", "" );
	
			update_option( "EWD_UFAQ_Styling_Question_Font", "" );
			update_option( "EWD_UFAQ_Styling_Question_Font_Size", "" );
			update_option( "EWD_UFAQ_Styling_Question_Font_Color", "" );
			update_option( "EWD_UFAQ_Styling_Question_Margin", "" );
			update_option( "EWD_UFAQ_Styling_Question_Padding", "" );
			update_option( "EWD_UFAQ_Styling_Question_Icon_Top_Margin", "" );
			update_option( "EWD_UFAQ_Styling_Answer_Font", "" );
			update_option( "EWD_UFAQ_Styling_Answer_Font_Size", "" );
			update_option( "EWD_UFAQ_Styling_Answer_Font_Color", "" );
			update_option( "EWD_UFAQ_Styling_Answer_Margin", "" );
			update_option( "EWD_UFAQ_Styling_Answer_Padding", "" );
			update_option( "EWD_UFAQ_Styling_Postdate_Font", "" );
			update_option( "EWD_UFAQ_Styling_Postdate_Font_Size", "" );
			update_option( "EWD_UFAQ_Styling_Postdate_Font_Color", "" );
			update_option( "EWD_UFAQ_Styling_Postdate_Margin", "" );
			update_option( "EWD_UFAQ_Styling_Postdate_Padding", "" );
			update_option( "EWD_UFAQ_Styling_Category_Font", "" );
			update_option( "EWD_UFAQ_Styling_Category_Font_Size", "" );
			update_option( "EWD_UFAQ_Styling_Category_Font_Color", "" );
			update_option( "EWD_UFAQ_Styling_Category_Margin", "" );
			update_option( "EWD_UFAQ_Styling_Category_Padding", "" );
		
			update_option( "EWD_UFAQ_Styling_Category_Heading_Type", "h4" );
			update_option( "EWD_UFAQ_Styling_FAQ_Heading_Type", "h4" );
			update_option( "EWD_UFAQ_Toggle_Symbol", "A" );
	
			update_option( "EWD_UFAQ_Full_Version", "No" );
		}
		
		update_option( "EWD_UFAQ_Trial_Happening", "No" );
		delete_option( "EWD_UFAQ_Trial_Expiry_Time" );
	}

	public function ewd_upcp_version_reversion() {
		global $wpdb;
		global $tags_table_name;
		global $fields_table_name;
		global $ewd_upcp_controller;

		if ( ! empty( $ewd_upcp_controller ) and is_object( $ewd_upcp_controller ) ) {

			$ewd_upcp_controller->settings->set_setting( 'product-page', 'default' );
			$ewd_upcp_controller->settings->set_setting( 'product-image-lightbox', 'no' );
			$ewd_upcp_controller->settings->set_setting( 'related-products', 'none' );
			$ewd_upcp_controller->settings->set_setting( 'next-previous-products', 'none' );
			$ewd_upcp_controller->settings->set_setting( 'lightbox-mode', '' );
			$ewd_upcp_controller->settings->set_setting( 'infinite-scroll', '' );
			$ewd_upcp_controller->settings->set_setting( 'products-per-page', '100' );
			$ewd_upcp_controller->settings->set_setting( 'pagination-location', 'top' );
			$ewd_upcp_controller->settings->set_setting( 'product-sort', '' );
			$ewd_upcp_controller->settings->set_setting( 'disable-toggle-sidebar-on-mobile', '' );
			$ewd_upcp_controller->settings->set_setting( 'product-inquiry-form', '' );
			$ewd_upcp_controller->settings->set_setting( 'product-inquiry-cart', '' );
			$ewd_upcp_controller->settings->set_setting( 'product-inquiry-plugin', 'wpforms' );
			$ewd_upcp_controller->settings->set_setting( 'product-reviews', '' );
			$ewd_upcp_controller->settings->set_setting( 'catalog-display-reviews', '' );
			$ewd_upcp_controller->settings->set_setting( 'product-faqs', '' );
			$ewd_upcp_controller->settings->set_setting( 'product-comparison', '' );
			$ewd_upcp_controller->settings->set_setting( 'hide-blank-custom-fields', '' );
			$ewd_upcp_controller->settings->set_setting( 'disable-custom-field-conversion', '' );

			$ewd_upcp_controller->settings->set_setting( 'woocommerce-sync', '' );
			$ewd_upcp_controller->settings->set_setting( 'woocommerce-disable-cart-count', '' );
			$ewd_upcp_controller->settings->set_setting( 'woocommerce-checkout', '' );
			$ewd_upcp_controller->settings->set_setting( 'woocommerce-cart-page', 'cart' );
			$ewd_upcp_controller->settings->set_setting( 'woocommerce-product-page', '' );
			$ewd_upcp_controller->settings->set_setting( 'woocommerce-back-link', '' );

			$ewd_upcp_controller->settings->set_setting( 'pretty-permalinks', '' );
			$ewd_upcp_controller->settings->set_setting( 'permalink-base', 'product' );
			$ewd_upcp_controller->settings->set_setting( 'seo-plugin', 'none' );
			$ewd_upcp_controller->settings->set_setting( 'seo-integration', 'add' );
			$ewd_upcp_controller->settings->set_setting( 'seo-title', '' );

			$ewd_upcp_controller->settings->set_setting( 'label-categories', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-subcategories', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-tags', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-show-all', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-sort-by', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-price-ascending', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-price-descending', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-name-ascending', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-name-descending', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-product-name-search', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-product-name-text', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-price-filter', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-updating-results', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-no-results-found', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-products-pagination', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-page', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-pagination-of', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-read-more', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-compare', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-side-by-side', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-sale', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-inquire-button', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-add-to-cart-button', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-send-inquiry', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-checkout', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-empty-cart', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-cart-items', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-back-to-catalog', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-product-details-tab', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-additional-info-tab', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-contact-form-tab', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-product-inquiry-form-title', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-customer-reviews-tab', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-related-products', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-next-product', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-previous-product', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-product-page-category', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-product-page-subcategory', '' );
			$ewd_upcp_controller->settings->set_setting( 'label-product-page-tags', '' );

			$ewd_upcp_controller->settings->set_setting( 'styling-fixed-thumbnail-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-catalog-skin', 'default' );
			$ewd_upcp_controller->settings->set_setting( 'styling-category-heading-style', 'normal' );
			$ewd_upcp_controller->settings->set_setting( 'styling-action-button-background-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-action-button-text-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-compare-button-background-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-compare-button-clicked-background-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-compare-button-text-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-compare-button-clicked-text-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-compare-button-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sale-button-background-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sale-button-text-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sale-button-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-product-comparison-title-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-product-comparison-title-font-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-product-comparison-price-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-product-comparison-price-font-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-product-comparison-price-background-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-thumbnail-view-image-border-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-thumbnail-view-box-min-height', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-thumbnail-view-box-max-height', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-thumbnail-view-box-padding', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-thumbnail-view-border-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-thumbnail-view-title-font', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-thumbnail-view-title-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-thumbnail-view-title-font-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-thumbnail-view-price-font', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-thumbnail-view-price-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-thumbnail-view-price-font-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-thumbnail-view-background-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-list-view-click-action', 'product' );
			$ewd_upcp_controller->settings->set_setting( 'styling-list-view-image-border-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-list-view-box-padding', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-list-view-box-margin-top', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-list-view-box-border-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-list-view-title-font', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-list-view-title-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-list-view-title-font-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-list-view-price-font', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-list-view-price-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-list-view-price-font-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-detail-view-image-border-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-detail-view-box-padding', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-detail-view-box-margin', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-detail-view-box-background-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-detail-view-border-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-detail-view-title-font', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-detail-view-title-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-detail-view-title-font-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-detail-view-price-font', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-detail-view-price-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-detail-view-price-font-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-title-collapse', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-start-collapsed', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-title-hover', 'none' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-checkbox-style', 'none' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-categories-control-type', 'checkbox' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-subcategories-control-type', 'checkbox' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-tags-control-type', 'checkbox' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-header-font', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-header-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-header-font-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-header-font-weight', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-checkbox-font', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-checkbox-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-checkbox-font-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-sidebar-checkbox-font-weight', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-styling-breadcrumbs-font', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-breadcrumbs-font', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-breadcrumbs-font-size', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-breadcrumbs-font-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-breadcrumbs-font-hover-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-pagination-background-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-pagination-text-color', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-pagination-background-color-hover', '' );
			$ewd_upcp_controller->settings->set_setting( 'styling-pagination-text-color-hover', '' );

			$ewd_upcp_controller->settings->save_settings();

			update_option( 'ewd-upcp-permission-level', 1 );
		}
		else {

			$wpdb->query("TRUNCATE $fields_table_name");
			$wpdb->query("TRUNCATE $tags_table_name");

			update_option( "UPCP_Product_Comparison", "No" );
			update_option( "UPCP_Product_Inquiry_Form", "No" );
			update_option( "UPCP_Product_Inquiry_Cart", "No" );
			update_option( "UPCP_Product_Reviews", "No" );
			update_option( "UPCP_Catalog_Display_Reviews", "No" );
			update_option( "UPCP_Lightbox", "No" );
			update_option( "UPCP_Lightbox_Mode", "No" );
			update_option( "UPCP_Hidden_Drop_Down_Sidebar_On_Mobile", "No" );
			update_option( "UPCP_Infinite_Scroll", "No" );
			update_option( "UPCP_Products_Per_Page", 1000000 );
			update_option( "UPCP_Pagination_Location", "Top" );
			update_option( "UPCP_CF_Conversion", "No" );
			update_option( "UPCP_Access_Role", "administrator" );
			update_option( "UPCP_PP_Grid_Width", 90 );
			update_option( "UPCP_PP_Grid_Height", 35 );
			update_option( "UPCP_Top_Bottom_Padding", 10 );
			update_option( "UPCP_Left_Right_Padding", 10 );

			update_option(	"UPCP_WooCommerce_Sync", "No" );
			update_option(	"UPCP_WooCommerce_Show_Cart_Count", "No" );
			update_option(	"UPCP_WooCommerce_Checkout", "No" );
			update_option(	"UPCP_WooCommerce_Cart_Page", "Checkout" );
			update_option(	"UPCP_WooCommerce_Product_Page", "No" );

			update_option( "UPCP_SEO_Option", "None" );
			update_option( "UPCP_SEO_Integration", "Add" );
			update_option( "UPCP_SEO_Title", "[page-title] |[product-name]" );
			update_option( "UPCP_Update_Breadcrumbs", "No" );

			update_option( "UPCP_Categories_Label", "" );
			update_option( "UPCP_SubCategories_Label", "" );
			update_option( "UPCP_Tags_Label", "" );
			update_option( "UPCP_Custom_Fields_Label", "" );
			update_option( "UPCP_Details_Label", "" );
			update_option( "UPCP_Sort_By_Label", "" );
			update_option( "UPCP_Price_Ascending_Label", "" );
			update_option( "UPCP_Price_Descending_Label", "" );
			update_option( "UPCP_Name_Ascending_Label", "" );
			update_option( "UPCP_Name_Descending_Label", "" );
			update_option( "UPCP_Product_Name_Search_Label", "" );
			update_option( "UPCP_Product_Name_Text_Label", "" );
			update_option( "UPCP_Back_To_Catalogue_Label", "" );
			update_option( "UPCP_Updating_Results_Label", "" );
			update_option( "UPCP_No_Results_Found_Label", "" );
			update_option( "UPCP_Products_Pagination_Label", "" );
			update_option( "UPCP_Read_More_Label", "" );
			update_option( "UPCP_Product_Details_Label", "" );
			update_option( "UPCP_Additional_Info_Label", "" );
			update_option( "UPCP_Contact_Us_Label", "" );
			update_option( "UPCP_Product_Inquiry_Form_Title_Label", "" );
			update_option( "UPCP_Customer_Reviews_Tab_Label", "" );
			update_option( "UPCP_Related_Products_Label", "" );
			update_option( "UPCP_Next_Product_Label", "" );
			update_option( "UPCP_Previous_Product_Label", "" );
			update_option( "UPCP_Of_Pagination_Label", "" );
			update_option( "UPCP_Inquire_Button_Label", "" );
			update_option( "UPCP_Add_To_Cart_Button_Label", "" );
			update_option( "UPCP_Send_Inquiry_Label", "" );
			update_option( "UPCP_Checkout_Label", "" );
			update_option( "UPCP_Empty_Cart_Label", "" );
			update_option( "UPCP_Additional_Info_Category_Label", "" );
			update_option( "UPCP_Additional_Info_SubCategory_Label", "" );
			update_option( "UPCP_Additional_Info_Tags_Label", "" );

			update_option( "UPCP_Catalogue_Style", "None" );
			update_option( "UPCP_Category_Heading_Style", "Normal" );
			update_option( "UPCP_Compare_Button_Background_Color", "" );
			update_option( "UPCP_Compare_Button_Text_Color", "" );
			update_option( "UPCP_Compare_Button_Clicked_Background_Color", "" );
			update_option( "UPCP_Compare_Button_Clicked_Text_Color", "" );
			update_option( "UPCP_Compare_Button_Font_Size", "" );
			update_option( "UPCP_Sale_Button_Background_Color", "" );
			update_option( "UPCP_Sale_Button_Text_Color", "" );
			update_option( "UPCP_Sale_Button_Font_Size", "" );
			update_option( "UPCP_Details_Icon_Type", "Default" );
			update_option( "UPCP_Details_Image", "" );
			update_option( "UPCP_Details_Icon_Color", "" );
			update_option( "UPCP_Details_Icon_Font_Size", "" );
			update_option( "UPCP_Details_Icon_Font_Selection", "" );

			update_option( "UPCP_Thumbnail_View_Image_Hover_Fade", "" );
			update_option( "UPCP_Thumbnail_View_Mouseover_Zoom", "" );
			update_option( "UPCP_Thumbnail_View_Image_Height", "" );
			update_option( "UPCP_Thumbnail_View_Image_Width", "" );
			update_option( "UPCP_Thumbnail_View_Image_Holder_Height", "" );
			update_option( "UPCP_Thumbnail_View_Image_Holder_Width", "" );
			update_option( "UPCP_Thumbnail_View_Image_Border", "" );
			update_option( "UPCP_Thumbnail_View_Image_Border_Color", "" );
			update_option( "UPCP_Thumbnail_View_Box_Width", "" );
			update_option( "UPCP_Thumbnail_View_Box_Min_Height", "" );
			update_option( "UPCP_Thumbnail_View_Box_Max_Height", "" );
			update_option( "UPCP_Thumbnail_View_Box_Padding", "" );
			update_option( "UPCP_Thumbnail_View_Box_Margin", "" );
			update_option( "UPCP_Thumbnail_View_Box_Border", "" );
			update_option( "UPCP_Thumbnail_View_Border_Color", "" );
			update_option( "UPCP_Thumbnail_View_Title_Font_Size", "" );
			update_option( "UPCP_Thumbnail_View_Title_Font", "" );
			update_option( "UPCP_Thumbnail_View_Title_Color", "" );
			update_option( "UPCP_Thumbnail_View_Price_Font", "" );
			update_option( "UPCP_Thumbnail_View_Price_Font_Size", "" );
			update_option( "UPCP_Thumbnail_View_Price_Color", "" );
			update_option( "UPCP_Thumbnail_View_Background_Color", "" );
			update_option( "UPCP_Thumbnail_View_Separator_Line", "" );
			update_option( "UPCP_Thumbnail_View_Details_Arrow", "" );
			update_option( "UPCP_Thumbnail_View_Custom_Details_Arrow", "" );

			update_option( "UPCP_List_View_Click_Action", "" );
			update_option( "UPCP_List_View_Image_Hover_Fade", "" );
			update_option( "UPCP_List_View_Mouseover_Zoom", "" );
			update_option( "UPCP_List_View_Image_Height", "" );
			update_option( "UPCP_List_View_Image_Width", "" );
			update_option( "UPCP_List_View_Image_Holder_Height", "" );
			update_option( "UPCP_List_View_Image_Border", "" );
			update_option( "UPCP_List_View_Image_Border_Color", "" );
			update_option( "UPCP_List_View_Image_Background_Color", "" );
			update_option( "UPCP_List_View_Item_Margin_Left", "" );
			update_option( "UPCP_List_View_Item_Margin_Top", "" );
			update_option( "UPCP_List_View_Item_Padding", "" );
			update_option( "UPCP_List_View_Item_Color", "" );
			update_option( "UPCP_List_View_Item_Min_Height", "" );
			update_option( "UPCP_List_View_Item_Max_Height", "" );
			update_option( "UPCP_List_View_Title_Font_Size", "" );
			update_option( "UPCP_List_View_Title_Color", "" );
			update_option( "UPCP_List_View_Title_Font", "" );
			update_option( "UPCP_List_View_Price_Font_Size", "" );
			update_option( "UPCP_List_View_Price_Color", "" );
			update_option( "UPCP_List_View_Price_Font", "" );
			update_option( "UPCP_List_View_Background_Color", "" );
			update_option( "UPCP_List_View_Details_Arrow", "" );
			update_option( "UPCP_List_View_Custom_Details_Arrow", "" );

			update_option( "UPCP_Detail_View_Image_Hover_Fade", "" );
			update_option( "UPCP_Detail_View_Mouseover_Zoom", "" );
			update_option( "UPCP_Detail_View_Image_Height", "" );
			update_option( "UPCP_Detail_View_Image_Width", "" );
			update_option( "UPCP_Detail_View_Image_Holder_Height", "" );
			update_option( "UPCP_Detail_View_Image_Holder_Width", "" );
			update_option( "UPCP_Detail_View_Image_Border", "" );
			update_option( "UPCP_Detail_View_Image_Border_Color", "" );
			update_option( "UPCP_Detail_View_Image_Background_Color", "" );
			update_option( "UPCP_Detail_View_Box_Width", "" );
			update_option( "UPCP_Detail_View_Box_Padding", "" );
			update_option( "UPCP_Detail_View_Box_Margin", "" );
			update_option( "UPCP_Detail_View_Box_Border", "" );
			update_option( "UPCP_Detail_View_Border_Color", "" );
			update_option( "UPCP_Detail_View_Title_Font_Size", "" );
			update_option( "UPCP_Detail_View_Title_Color", "" );
			update_option( "UPCP_Detail_View_Title_Font", "" );
			update_option( "UPCP_Detail_View_Price_Font_Size", "" );
			update_option( "UPCP_Detail_View_Price_Color", "" );
			update_option( "UPCP_Detail_View_Price_Font", "" );
			update_option( "UPCP_Detail_View_Zoom_On_Image_Hover", "" );
			update_option( "UPCP_Detail_View_Background_Color", "" );
			update_option( "UPCP_Detail_View_Separator_Line", "" );
			update_option( "UPCP_Detail_View_Details_Arrow", "" );
			update_option( "UPCP_Detail_View_Custom_Details_Arrow", "" );

			update_option( "UPCP_Sidebar_Title_Collapse", "no" );
			update_option( "UPCP_Sidebar_Subcat_Collapse", "" );
			update_option( "UPCP_Sidebar_Start_Collapsed", "no" );
			update_option( "UPCP_Sidebar_Title_Hover", "none" );
			update_option( "UPCP_Sidebar_Checkbox_Style", "none" );
			update_option( "UPCP_Custom_Fields_Show_Hide", "" );
			update_option( "UPCP_Categories_Control_Type", "Checkbox" );
			update_option( "UPCP_SubCategories_Control_Type", "Checkbox" );
			update_option( "UPCP_Tags_Control_Type", "Checkbox" );
			update_option( "UPCP_Sidebar_Header_Font", "" );
			update_option( "UPCP_Sidebar_Header_Font_Size", "" );
			update_option( "UPCP_Sidebar_Header_Font_Weight", "" );
			update_option( "UPCP_Sidebar_Header_Color", "" );
			update_option( "UPCP_Sidebar_Subheader_Font", "" );
			update_option( "UPCP_Sidebar_Subheader_Font_Size", "" );
			update_option( "UPCP_Sidebar_Subheader_Font_Weight", "" );
			update_option( "UPCP_Sidebar_Subheader_Color", "" );
			update_option( "UPCP_Sidebar_Checkbox_Font", "" );
			update_option( "UPCP_Sidebar_Checkbox_Font_Size", "" );
			update_option( "UPCP_Sidebar_Checkbox_Font_Weight", "" );
			update_option( "UPCP_Sidebar_Checkbox_Color", "" );

			update_option( "UPCP_Full_Version", "No" );
		}

		update_option( 'EWD_UPCP_Trial_Happening', 'No' );
		delete_option( 'EWD_UPCP_Trial_Expiry_Time' );
	}

	public function ewd_urp_version_reversion() {
		global $ewd_urp_controller;

		if ( ! empty( $ewd_urp_controller ) and is_object( $ewd_urp_controller ) ) {

			$ewd_urp_controller->settings->set_setting( 'review-format', 'standard' );
			$ewd_urp_controller->settings->set_setting( 'summary-statistics', 'none' );
			$ewd_urp_controller->settings->set_setting( 'display-microdata', false );
			$ewd_urp_controller->settings->set_setting( 'thumbnail-characters', '140' );
			$ewd_urp_controller->settings->set_setting( 'replace-woocommerce-reviews', false );
			$ewd_urp_controller->settings->set_setting( 'override-woocommerce-ratings-display', false );
			$ewd_urp_controller->settings->set_setting( 'review-karma', false );
			$ewd_urp_controller->settings->set_setting( 'use-captcha', false );
			$ewd_urp_controller->settings->set_setting( 'infinite-scroll', false );
			$ewd_urp_controller->settings->set_setting( 'admin-notification', false );
			$ewd_urp_controller->settings->set_setting( 'admin-approval', false );
			$ewd_urp_controller->settings->set_setting( 'require-email', false );
			$ewd_urp_controller->settings->set_setting( 'email-confirmation', false );
			$ewd_urp_controller->settings->set_setting( 'display-on-confirmation', false );
			$ewd_urp_controller->settings->set_setting( 'require-login', false );

			$ewd_urp_controller->settings->set_setting( 'label-posted', '' );
			$ewd_urp_controller->settings->set_setting( 'label-by', '' );
			$ewd_urp_controller->settings->set_setting( 'label-on', '' );
			$ewd_urp_controller->settings->set_setting( 'label-score', '' );
			$ewd_urp_controller->settings->set_setting( 'label-explanation', '' );
			$ewd_urp_controller->settings->set_setting( 'label-submit-product', '' );
			$ewd_urp_controller->settings->set_setting( 'label-submit-author', '' );
			$ewd_urp_controller->settings->set_setting( 'label-submit-author-comment', '' );
			$ewd_urp_controller->settings->set_setting( 'label-submit-title', '' );
			$ewd_urp_controller->settings->set_setting( 'label-submit-title-comment', '' );
			$ewd_urp_controller->settings->set_setting( 'label-submit-score', '' );
			$ewd_urp_controller->settings->set_setting( 'label-submit-review', '' );
			$ewd_urp_controller->settings->set_setting( 'label-submit-element-score', '' );
			$ewd_urp_controller->settings->set_setting( 'label-submit-explanation', '' );
			$ewd_urp_controller->settings->set_setting( 'label-submit-button', '' );
			$ewd_urp_controller->settings->set_setting( 'label-submit-success-message', '' );
			$ewd_urp_controller->settings->set_setting( 'label-submit-draft-message', '' );

			$ewd_urp_controller->settings->set_setting( 'styling-review-title-font', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-title-font-size', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-title-font-color', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-title-margin', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-title-padding', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-content-font', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-content-font-size', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-content-font-color', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-content-margin', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-content-padding', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-date-font', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-date-font-size', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-date-font-color', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-date-margin', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-date-padding', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-score-font', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-score-font-size', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-score-font-color', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-score-margin', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-score-padding', '' );

			$ewd_urp_controller->settings->set_setting( 'styling-summary-stats-color', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-simple-bar-color', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-color-bar-high', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-color-bar-medium', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-color-bar-low', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-background-color', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-header-background-color', '' );
			$ewd_urp_controller->settings->set_setting( 'styling-review-content-background-color', '' );

			$ewd_urp_controller->settings->save_settings();

			update_option( 'ewd-urp-permission-level', 1 );
		}
		else {
			update_option( "EWD_URP_Review_Format", "Standard" );
			update_option( "EWD_URP_Summary_Statistics", "None" );
			update_option( "EWD_URP_Display_Microdata", "No" );
			update_option( "EWD_URP_Thumbnail_Characters", "140" );
			update_option( "EWD_URP_Replace_WooCommerce_Reviews", "No" );
			update_option( "EWD_URP_Override_WooCommerce_Theme", "No" );
			update_option( "EWD_URP_Review_Weights", "No" );
			update_option( "EWD_URP_Review_Karma", "No" );
			update_option( "EWD_URP_Use_Captcha", "No" );
			update_option( "EWD_URP_Infinite_Scroll", "No" );
			update_option( "EWD_URP_Admin_Notification", "No" );
			update_option( "EWD_URP_Admin_Approval", "No" );
			update_option( "EWD_URP_Require_Email", "No" );
			update_option( "EWD_URP_Email_Confirmation", "No" );
			update_option( "EWD_URP_Display_On_Confirmation", "Yes" );
			update_option( "EWD_URP_Require_Login", "No" );
			update_option( "EWD_URP_Login_Options", array() );

			update_option( "EWD_URP_Posted_Label", "" );
			update_option( "EWD_URP_By_Label", "" );
			update_option( "EWD_URP_On_Label", "" );
			update_option( "EWD_URP_Score_Label", "" );
			update_option( "EWD_URP_Explanation_Label", "" );
			update_option( "EWD_URP_Submit_Product_Label", "" );
			update_option( "EWD_URP_Submit_Author_Label", "" );
			update_option( "EWD_URP_Submit_Author_Comment_Label", "" );
			update_option( "EWD_URP_Submit_Title_Label", "" );
			update_option( "EWD_URP_Submit_Title_Comment_Label", "" );
			update_option( "EWD_URP_Submit_Score_Label", "" );
			update_option( "EWD_URP_Submit_Review_Label", "" );
			update_option( "EWD_URP_Submit_Cat_Score_Label", "" );
			update_option( "EWD_URP_Submit_Explanation_Label", "" );
			update_option( "EWD_URP_Submit_Button_Label", "" );
			update_option( "EWD_URP_Submit_Success_Message", "" );
			update_option( "EWD_URP_Submit_Draft_Message", "" );
		
			update_option( "EWD_urp_Review_Title_Font", "" );
			update_option( "EWD_urp_Review_Title_Font_Size", "" );
			update_option( "EWD_urp_Review_Title_Font_Color", "" );
			update_option( "EWD_urp_Review_Title_Margin", "" );
			update_option( "EWD_urp_Review_Title_Padding", "" );
			update_option( "EWD_urp_Review_Content_Font", "" );
			update_option( "EWD_urp_Review_Content_Font_Size", "" );
			update_option( "EWD_urp_Review_Content_Font_Color", "" );
			update_option( "EWD_urp_Review_Content_Margin", "" );
			update_option( "EWD_urp_Review_Content_Padding", "" );
			update_option( "EWD_urp_Review_Postdate_Font", "" );
			update_option( "EWD_urp_Review_Postdate_Font_Size", "" );
			update_option( "EWD_urp_Review_Postdate_Font_Color", "" );
			update_option( "EWD_urp_Review_Postdate_Margin", "" );
			update_option( "EWD_urp_Review_Postdate_Padding", "" );
			update_option( "EWD_urp_Review_Score_Font", "" );
			update_option( "EWD_urp_Review_Score_Font_Size", "" );
			update_option( "EWD_urp_Review_Score_Font_Color", "" );
			update_option( "EWD_urp_Review_Score_Margin", "" );
			update_option( "EWD_urp_Review_Score_Padding", "" );
		
			update_option( "EWD_urp_Summary_Stats_Color", "" );
			update_option( "EWD_urp_Simple_Bar_Color", "" );
			update_option( "EWD_urp_Color_Bar_High", "" );
			update_option( "EWD_urp_Color_Bar_Medium", "" );
			update_option( "EWD_urp_Color_Bar_Low", "" );
			update_option( "EWD_urp_Review_Background_Color", "" );
			update_option( "EWD_urp_Review_Header_Background_Color", "" );
			update_option( "EWD_urp_Review_Content_Background_Color", "" );

			update_option( "EWD_URP_Full_Version", "No" );
		}
		update_option( "EWD_URP_Trial_Happening", "No" );
		delete_option( "EWD_URP_Trial_Expiry_Time" );
	}

	public function ewd_us_version_reversion() {
		global $ewd_us_controller;

		if ( ! empty( $ewd_us_controller ) and is_object( $ewd_us_controller ) ) {

			$ewd_us_controller->settings->set_setting( 'slide-transition-effect', 'slide' );
			$ewd_us_controller->settings->set_setting( 'wc-product-image-slider', false );
			$ewd_us_controller->settings->set_setting( 'mobile-aspect-ratio', '16_7' );
			$ewd_us_controller->settings->set_setting( 'hide-from-slider', array() );
			$ewd_us_controller->settings->set_setting( 'hide-on-mobile', array( 'body', 'buttons' ) );
			$ewd_us_controller->settings->set_setting( 'mobile-link-to-full', false );
			$ewd_us_controller->settings->set_setting( 'add-watermark', false );
			$ewd_us_controller->settings->set_setting( 'title-animate', 'none' );
			$ewd_us_controller->settings->set_setting( 'lightbox', false );
			$ewd_us_controller->settings->set_setting( 'youtube-autoplay-video', false );
			$ewd_us_controller->settings->set_setting( 'youtube-show-content', false );
			$ewd_us_controller->settings->set_setting( 'youtube-video-opacity', '' );

			$ewd_us_controller->settings->set_setting( 'styling-slide-title-font', '' );
			$ewd_us_controller->settings->set_setting( 'styling-slide-title-font-size', '' );
			$ewd_us_controller->settings->set_setting( 'styling-slide-title-font-color', '' );
			$ewd_us_controller->settings->set_setting( 'styling-slide-text-font', '' );
			$ewd_us_controller->settings->set_setting( 'styling-slide-text-font-size', '' );
			$ewd_us_controller->settings->set_setting( 'styling-slide-text-font-color', '' );
			$ewd_us_controller->settings->set_setting( 'styling-button-font', '' );
			$ewd_us_controller->settings->set_setting( 'styling-button-font-size', '' );
			$ewd_us_controller->settings->set_setting( 'styling-button-background-color', '' );
			$ewd_us_controller->settings->set_setting( 'styling-button-border-color', '' );
			$ewd_us_controller->settings->set_setting( 'styling-button-text-color', '' );
			$ewd_us_controller->settings->set_setting( 'styling-button-background-hover-color', '' );
			$ewd_us_controller->settings->set_setting( 'styling-button-border-hover-color', '' );
			$ewd_us_controller->settings->set_setting( 'styling-button-text-hover-color', '' );

			$ewd_us_controller->settings->set_setting( 'arrow', 'a' );
			$ewd_us_controller->settings->set_setting( 'arrow-background-shape', 'none' );
			$ewd_us_controller->settings->set_setting( 'styling-arrow-color', '' );
			$ewd_us_controller->settings->set_setting( 'styling-arrow-font-size', '' );
			$ewd_us_controller->settings->set_setting( 'styling-arrow-background-color', '' );
			$ewd_us_controller->settings->set_setting( 'styling-arrow-background-size', '' );
			$ewd_us_controller->settings->set_setting( 'styling-clickable-area-background-color', '' );
			$ewd_us_controller->settings->set_setting( 'styling-clickable-area-size', '' );
			$ewd_us_controller->settings->set_setting( 'styling-arrow-line-height', '1.25' );

			$ewd_us_controller->settings->save_settings();

			update_option( 'ewd-us-permission-level', 1 );
		}
		else {
			update_option( "EWD_US_Slide_Transition_Effect", "slide" );
    		update_option( "EWD_US_Mobile_Aspect_Ratio", get_option("EWD_US_Aspect_Ratio") );
    		update_option( "EWD_US_Hide_On_Mobile", array('body', 'buttons') );
    		update_option( "EWD_US_Mobile_Link_To_Full", "No" );
    		update_option( "EWD_US_Add_Watermark", "No" );
    		update_option( "EWD_US_Title_Animate", "None" );
    		update_option( "EWD_US_Lightbox", "No" );

    		update_option( "EWD_us_Slide_Title_Font", "" );
			update_option( "EWD_us_Slide_Title_Font_Size", "" );
			update_option( "EWD_us_Slide_Title_Font_Color", "" );
			update_option( "EWD_us_Slide_Text_Font", "" );
			update_option( "EWD_us_Slide_Text_Font_Size", "" );
			update_option( "EWD_us_Slide_Text_Font_Color", "" );
			update_option( "EWD_us_Button_Font", "" );
			update_option( "EWD_us_Button_Font_Size", "" );
			update_option( "EWD_us_Button_Background_Color", "" );
			update_option( "EWD_us_Button_Border_Color", "" );
			update_option( "EWD_us_Button_Text_Color", "" );
			update_option( "EWD_us_Button_Background_Hover_Color", "" );
			update_option( "EWD_us_Button_Border_Hover_Color", "" );
			update_option( "EWD_us_Button_Text_Hover_Color", "" );
	
			update_option( "EWD_us_Arrow", "a" );
			update_option( "EWD_us_Arrow_Background_Shape", "None" );
			update_option( "EWD_us_Arrow_Color", "" );
			update_option( "EWD_us_Arrow_Font_Size", "" );
			update_option( "EWD_us_Arrow_Background_Color", "" );
			update_option( "EWD_us_Arrow_Background_Size", "" );
			update_option( "EWD_us_Clickable_Area_Background_Color", "" );
			update_option( "EWD_us_Clickable_Area_Size", "" );
			update_option( "EWD_us_Arrow_Line_Height", "1.25" );

			update_option( "EWD_US_Full_Version", "No" );
		}
		update_option( "EWD_US_Trial_Happening", "No" );
		delete_option( "EWD_US_Trial_Expiry_Time" );
	}

	public function ewd_uwcf_version_reversion() {
		global $wpdb;
		global $ewd_uwcf_controller;

		$fields_array = array('name', 'image', 'price', 'rating', 'add_to_cart', 'colors', 'sizes');

		$wc_attribute_table_name = $wpdb->prefix . "woocommerce_attribute_taxonomies";
    	$attribute_taxonomies = $wpdb->get_results( "SELECT * FROM $wc_attribute_table_name order by attribute_name ASC;" );

		if ( ! empty( $ewd_uwcf_controller ) and is_object( $ewd_uwcf_controller ) ) {

			$ewd_uwcf_controller->settings->set_setting( 'color-filtering-display', 'list' );
			$ewd_uwcf_controller->settings->set_setting( 'color-filtering-display-thumbnail-colors', false );
			$ewd_uwcf_controller->settings->set_setting( 'color-filtering-product-page-display', false );
			$ewd_uwcf_controller->settings->set_setting( 'color-filtering-colors-for-variations', false );

			$ewd_uwcf_controller->settings->set_setting( 'size-filtering-display', 'list' );
			$ewd_uwcf_controller->settings->set_setting( 'size-filtering-display-thumbnail-sizes', false );
			$ewd_uwcf_controller->settings->set_setting( 'size-filtering-product-page-display', false );
			$ewd_uwcf_controller->settings->set_setting( 'size-filtering-sizes-for-variations', false );

			$ewd_uwcf_controller->settings->set_setting( 'category-filtering-display', 'list' );
			$ewd_uwcf_controller->settings->set_setting( 'category-filtering-display-thumbnail-cats', false );

			$ewd_uwcf_controller->settings->set_setting( 'tag-filtering-display', 'list' );
			$ewd_uwcf_controller->settings->set_setting( 'tag-filtering-display-thumbnail-tags', false );

			foreach ( $attribute_taxonomies as $attribute_taxonomy ) {
				$ewd_uwcf_controller->settings->set_setting( $attribute_taxonomy->attribute_name . '-display', 'list' );
				$ewd_uwcf_controller->settings->set_setting( $attribute_taxonomy->attribute_name . '-display-thumbnail-terms', false );
			}

			$ewd_uwcf_controller->settings->set_setting( 'label-color-filters', '' );
			$ewd_uwcf_controller->settings->set_setting( 'label-show-all-color', '' );
			$ewd_uwcf_controller->settings->set_setting( 'label-show-all-size', '' );
			$ewd_uwcf_controller->settings->set_setting( 'label-show-all-category', '' );
			$ewd_uwcf_controller->settings->set_setting( 'label-show-all-tag', '' );
			$ewd_uwcf_controller->settings->set_setting( 'label-show-all-attribute', '' );
			$ewd_uwcf_controller->settings->set_setting( 'label-rating', '' );
			$ewd_uwcf_controller->settings->set_setting( 'label-thumbnail-colors', '' );
			$ewd_uwcf_controller->settings->set_setting( 'label-thumbnail-sizes', '' );
			$ewd_uwcf_controller->settings->set_setting( 'label-thumbnail-categories', '' );
			$ewd_uwcf_controller->settings->set_setting( 'label-thumbnail-tags', '' );
			$ewd_uwcf_controller->settings->set_setting( 'label-product-page-colors', '' );
			$ewd_uwcf_controller->settings->set_setting( 'label-product-page-sizes', '' );

			$ewd_uwcf_controller->settings->set_setting( 'styling-color-filter-shape', 'circle' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-color-icon-size', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-widget-font-color', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-widget-font-size', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-ratings-bar-fill-color', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-ratings-bar-empty-color', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-ratings-bar-handle-color', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-ratings-bar-text-color', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-ratings-bar-font-size', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-reset-all-button-background-color', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-reset-all-button-text-color', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-reset-all-button-hover-bg-color', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-reset-all-button-hover-text-color', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-reset-all-button-font-size', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-shop-thumbnails-font-color', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-shop-thumbnails-font-size', '' );
			$ewd_uwcf_controller->settings->set_setting( 'styling-shop-thumbnails-color-icon-size', '' );

			$ewd_uwcf_controller->settings->save_settings();

			update_option( 'ewd-uwcf-permission-level', 1 );
		}
		else {

			update_option( "EWD_UWCF_Color_Filters_Display", "List" );
			update_option( "EWD_UWCF_Display_Thumbnail_Colors", "No" );
			update_option( "EWD_UWCF_Colors_Product_Page_Display", "No" );
			update_option( "EWD_UWCF_Colors_Used_For_Variations", "No" );

			update_option( "EWD_UWCF_Size_Filters_Display", "List" );
			update_option( "EWD_UWCF_Display_Thumbnail_Sizes", "No" );
			update_option( "EWD_UWCF_Sizes_Product_Page_Display", "No" );
			update_option( "EWD_UWCF_Sizes_Used_For_Variations", "No" );

			update_option( "EWD_UWCF_Category_Filters_Display", "List" );
			update_option( "EWD_UWCF_Display_Thumbnail_Categories", "No" );

			update_option( "EWD_UWCF_Tag_Filters_Display", "List" );
			update_option( "EWD_UWCF_Display_Thumbnail_Tags", "No" );

			foreach ( $attribute_taxonomies as $attribute_taxonomy ) {
				update_option( "EWD_UWCF_" . $attribute_taxonomy->attribute_name . "_Display", "List" );
				update_option( "EWD_UWCF_" . $attribute_taxonomy->attribute_name . "_Thumbnail_Tags", "No" );
		
				$fields_array[] = $attribute_taxonomy->attribute_name;
			}
		
			update_option( "EWD_UWCF_Fields_Array", $fields_array );

			update_option( "EWD_UWCF_Color_Filters_Label", "" );
			update_option( "EWD_UWCF_Show_All_Colors_Label", "" );
			update_option( "EWD_UWCF_Show_All_Sizes_Label", "" );
			update_option( "EWD_UWCF_Show_All_Categories_Label", "" );
			update_option( "EWD_UWCF_Show_All_Tags_Label", "" );
			update_option( "EWD_UWCF_Show_All_Attributes_Label", "" );
			update_option( "EWD_UWCF_Rating_Label", "" );
			update_option( "EWD_UWCF_Thumbnail_Colors_Label", "" );
			update_option( "EWD_UWCF_Thumbnail_Sizes_Label", "" );
			update_option( "EWD_UWCF_Thumbnail_Categories_Label", "" );
			update_option( "EWD_UWCF_Thumbnail_Tags_Label", "" );
			update_option( "EWD_UWCF_Product_Page_Colors_Label", "" );
			update_option( "EWD_UWCF_Product_Page_Sizes_Label", "" );

			update_option( "EWD_UWCF_Color_Filters_Color_Shape", "Circle" );
			update_option( "EWD_UWCF_Color_Icon_Size", "" );
			update_option( "EWD_UWCF_Widget_Font_Color", "" );
			update_option( "EWD_UWCF_Widget_Font_Size", "" );
			update_option( "EWD_UWCF_Ratings_Bar_Fill_Color", "" );
			update_option( "EWD_UWCF_Ratings_Bar_Empty_Color", "" );
			update_option( "EWD_UWCF_Ratings_Bar_Handle_Color", "" );
			update_option( "EWD_UWCF_Ratings_Bar_Text_Color", "" );
			update_option( "EWD_UWCF_Ratings_Bar_Font_Size", "" );
			update_option( "EWD_UWCF_Reset_All_Button_Background_Color", "" );
			update_option( "EWD_UWCF_Reset_All_Button_Text_Color", "" );
			update_option( "EWD_UWCF_Reset_All_Button_Hover_Background_Color", "" );
			update_option( "EWD_UWCF_Reset_All_Button_Hover_Text_Color", "" );
			update_option( "EWD_UWCF_Reset_All_Button_Font_Size", "" );
			update_option( "EWD_UWCF_Shop_Thumbnails_Font_Color", "" );
			update_option( "EWD_UWCF_Shop_Thumbnails_Font_Size", "" );
			update_option( "EWD_UWCF_Shop_Thumbnails_Color_Icon_Size", "" );

			update_option( "EWD_UWCF_Full_Version", "No" );
		}

		update_option( "EWD_UWCF_Trial_Happening", "No" );
		delete_option( "EWD_UWCF_Trial_Expiry_Time" );
	}

	public function ewd_otp_trial_end_wc_status_check() {
		global $wpdb;

		$statuses_array = get_option( "EWD_OTP_Statuses_Array" );
		if ( ! is_array( $statuses_array ) ) { $statuses_array = array(); }

		foreach ( $statuses_array as $status_array_item ) {
			$sanitized_title = sanitize_title( $status_array_item['Status'] );
	
			$wpdb->query( $wpdb->prepare( "SELECT ID FROM $wpdb->posts WHERE post_type='shop_order' AND post_status=%s", 'wc-' . $sanitized_title ) );
			if ( $wpdb->num_rows ) { update_option( "EWD_OTP_Trial_End_WooCommerce_Statuses_Maintain", "Yes" ); }
		}
	}
}
}
